/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is tkishdemos.
 *
 * The Initial Developer of the Original Code is
 * M.D. Nauta.
 * Portions created by the Initial Developer are Copyright (C) 2004
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */


function fileOpen() {
	filePicker2textbox(
		document.getElementById('file2open'),
		document.getElementById('strings').getString('openFileTitle'),
		'open');
}

function fileSave() {
	filePicker2textbox(
		document.getElementById('file2save'),
		document.getElementById('strings').getString('saveFileTitle'),
		'save');
}

function filePicker2textbox(textboxEl,dialogTitle,dialogMode) {
	var strbundle = document.getElementById('strings');
	try {
		var nsIFilePicker = Components.interfaces.nsIFilePicker;
		var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	} catch (e) {
		return false;
	}
	if (dialogMode == 'open') fp.init(window,dialogTitle,nsIFilePicker.modeOpen);
	else if (dialogMode == 'save') {
		fp.init(window,dialogTitle,nsIFilePicker.modeSave);
		fp.defaultString = strbundle.getString('defaultSaveName');
	}
	else return;
	try {
		var dserv = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties);
		var achrome = dserv.get("AChrom",Components.interfaces.nsIFile);
		if (achrome.exists() && achrome.isDirectory()) {
			fp.displayDirectory = achrome;
		}
	} catch (e) {
		alert("Can't set the default directory to display in the filepicker: " + e);
	}
	fp.appendFilter(strbundle.getString('textFilter'),"*.txt; *.doc");
	fp.appendFilter(strbundle.getString('tclFilter'),"*.tcl");
	fp.appendFilter(strbundle.getString('cFilter'),"*.c; *.h");
	fp.appendFilter(strbundle.getString('allSourceFilter'),"*.tcl; *.c; *.h");
	fp.appendFilter(strbundle.getString('imageFilter'),"*.gif; *.jpeg; *.jpg");
	fp.appendFilter(strbundle.getString('allFilter'),"*.*");
	var res=fp.show();
	if (res==nsIFilePicker.returnOK) {
		textboxEl.setAttribute('value',fp.file.path);
		textboxEl.inputField.scrollLeft = textboxEl.inputField.scrollWidth;
	}
}
