/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is tkishdemos.
 *
 * The Initial Developer of the Original Code is
 * M.D. Nauta.
 * Portions created by the Initial Developer are Copyright (C) 2004
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */


function initialize() {
	// Set initial value for directory.
	var dirTextbox = document.getElementById('dir');
	try {
		var dserv = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties);
		var ares = dserv.get("ARes",Components.interfaces.nsIFile);
		ares.QueryInterface(Components.interfaces.nsILocalFile);
		ares.appendRelativePath('samples');
		if (ares.exists() && ares.isDirectory())
			dirTextbox.value = ares.path;
	} catch(e) {
		alert("Can't set an initial value for the directory: " + e);
	}
	document.getElementById('imageTag').successSrc = undefined;
}

function listImageFiles(directory) {
	var i;
	try {
		var aDir = Components.classes["@mozilla.org/filespec;1"].createInstance(Components.interfaces.nsIFileSpec);
		aDir.nativePath = directory;
		if (!aDir.isDirectory()) throw ('no files matched glob pattern "' + directory + '\*"');
	} catch (e) {
		alert("Error: " + e);
		return false;
	}
	var filenames = new Array(0);
	try {
		var iterator = Components.classes["@mozilla.org/directoryiterator;1"].createInstance(Components.interfaces.nsIDirectoryIterator);
		iterator.init(aDir,false);
		while (iterator.exists()) {
			filenames.push(iterator.currentSpec.leafName);
			iterator.next();
		}
	} catch (e) {
		alert("Can't read filenames: " + e);
		return false;
	}
	filenames = filenames.sort();
	// Add files to listbox.
	var listbox = document.getElementById('files');
	var childNodes = listbox.childNodes;
	for (i=0; i<childNodes.length; i++) {
		listbox.removeChild(childNodes.item(i));
	}
	for (i=0; i<filenames.length; i++) {
		var item = document.createElement('listitem');
		item.setAttribute('label',filenames[i]);
		item.setAttribute('crop','none');
		item.setAttribute('ondblclick','displayImage("' +
			filenames[i] + '");');
		listbox.appendChild(item);
	}
	return true;
}

function displayImage(filename) {
	try {
		var filepath = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
		filepath.initWithPath(document.getElementById('dir').value);
		filepath.appendRelativePath(filename);
		if (!filepath.exists()) throw('Can\'t find file "' + filepath +'".');
	} catch (e) {
		alert("Trouble reading the file: " + e);
		return false;
	}
	var image = document.getElementById('imageTag');
	image.src = 'file:///' + filepath.path;
	return true;
}

function imageError(filename,lastSuccessfulSrc) {
	if (lastSuccessfulSrc) 
		document.getElementById('imageTag').src = lastSuccessfulSrc;
	alert('Error: couldn\'t recognize data in image file: "' + filename + '"');
}
